<app-navbar-top-menu [listMenu]="listMenu"></app-navbar-top-menu>

<mat-card>
  <form focusInvalidInput [formGroup]="searchform">
    <div class="card-body py-0 fs-7">
      <div class="row">
        <div class="col-md-6 col-lg-3">
          <div class="col-auto">
            <label for="projectName" class="col-auto col-form-label"><em class="text-danger">*</em>ค้นหาโครงการ/งาน</label>
          </div>
          <div class="col-12">
            <mat-form-field appearance="outline" floatLabel="always">
              <input matInput placeholder="โครงการ" id="projectName" formControlName="projectName" readonly (click)="selectProject()" (keydown)="selectProject()" />
              <input type="hidden"id="projectCode" formControlName="projectCode" />
              <button color="primary" mat-button mat-icon-button matSuffix (click)="selectProject()">
                <mat-icon>filter_alt</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
  
        <div class="col-md-6 col-lg-3">
          <div class="col-auto">
            <label for="projectBudgetName" class="col-auto col-form-label">ค้นหาแผนโครงการ/งาน</label>
          </div>
          <div class="col-12">
            <mat-form-field appearance="outline" floatLabel="always">
              <input matInput placeholder="แผนงาน" id="projectBudgetName" formControlName="projectBudgetName" readonly (click)="selectProjectBudget()" (keydown)="selectProjectBudget()" />
              <input type="hidden"id="projectBudgetCode" formControlName="projectBudgetCode" />
              <button color="primary" mat-button mat-icon-button matSuffix (click)="selectProjectBudget()">
                <mat-icon>filter_alt</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
  
        <div class="col-md-6 col-lg-3">
          <div class="col-auto">
            <label for="saletype" class="col-auto col-form-label">ประเภทการจัดซื้อ</label>
          </div>
          <div class="col-12">
            <mat-form-field appearance="outline" floatLabel="always">
              <mat-select placeholder="ประเภทการจัดซื้อ" id="saletype" formControlName="projectCategoryCode">
                <mat-option *ngFor="let item of projectCategoryList" [value]="item.code">
                  {{ item.name }}
                </mat-option>
              </mat-select>
            </mat-form-field>
          </div>
        </div>
  
        <div class="col-md-6 col-lg-3">
          <div class="col-auto">
            <label for="year" class="col-auto col-form-label"><em class="text-danger">**</em>ประจำปี</label>
          </div>
          <div class="col-12">
            <mat-form-field appearance="outline" floatLabel="always" appDateFormatYYYY>
              <input matInput [matDatepicker]="matPickerYYYY" id="year" [formControl]="date" formControlName="budgetYear" />
              <mat-datepicker-toggle matSuffix [for]="matPickerYYYY"></mat-datepicker-toggle>
              <mat-datepicker-toggle matSuffix (click)="clearDatepicker('budgetYear')">
                <mat-icon matDatepickerToggleIcon>clear</mat-icon>
              </mat-datepicker-toggle>
              <mat-datepicker #matPickerYYYY startView="multi-year" (yearSelected)="chooseYearHandler($event, matPickerYYYY)" panelClass="example-month-picker"> </mat-datepicker>
            </mat-form-field>
          </div>
        </div>
      </div>
      <div class="d-flex flex-row-reverse m-0">
        <button class="mx-2 fs-7" mat-raised-button (click)="clear()">เคลียร์</button>
        <button class="mx-2 fs-7" mat-raised-button color="primary" (click)="onSearch()">ค้นหา</button>
      </div>


    </div>
  </form>
  <div>

    <div class="d-flex justify-content-start flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
      <label class="font-black col-auto col-form-label">โครงการ/งาน</label>
      <div class="btn-group m-2">
        <button mat-stroked-button color="primary" (click)="onCreateProject()">
          <mat-icon aria-hidden="false" aria-label="add">add</mat-icon>
          เพิ่มโครงการ
        </button>
      </div>
    </div>

    <div class="mat-elevation-z0" style="overflow-x: auto;">
      <table mat-table [dataSource]="dataSource" class="data-table" aria-describedby="ตารางข้อมูล">
        <!-- Position Column -->
        <ng-container matColumnDef="index">
          <th id="index" mat-header-cell *matHeaderCellDef>#</th>
          <td mat-cell *matCellDef="let element; let i = index">{{ i + 1 }}</td>
        </ng-container>

        <ng-container matColumnDef="projectCode">
          <th id="projectCode" mat-header-cell *matHeaderCellDef>รหัสโครงการ/งาน</th>
          <td mat-cell *matCellDef="let element">{{ element.projectCode | slice: 0:8 }}</td>
        </ng-container>

        <ng-container matColumnDef="projectName">
          <th id="projectName" mat-header-cell *matHeaderCellDef>ชื่อโครงการ/งาน</th>
          <td mat-cell *matCellDef="let element">{{ element.projectName }}</td>
        </ng-container>

        <ng-container matColumnDef="projectMethodName">
          <th id="projectMethodName" mat-header-cell *matHeaderCellDef>วิธีการจัดหาพัสดุ</th>
          <td mat-cell *matCellDef="let element">{{ element.projectMethodName }}</td>
        </ng-container>

        <ng-container matColumnDef="budgetYear">
          <th id="budgetYear" mat-header-cell *matHeaderCellDef>ประจำปี</th>
          <td mat-cell *matCellDef="let element">{{ element.budgetYear | thaidate: 'yyyy' }}</td>
        </ng-container>

        <ng-container matColumnDef="projectCategoryName">
          <th id="projectCategoryName" mat-header-cell *matHeaderCellDef>ประเภทการจัดหาพัสดุ</th>
          <td mat-cell *matCellDef="let element">{{ element.projectCategoryName }}</td>
        </ng-container>

        <ng-container matColumnDef="projectBudgetAmt">
          <th id="projectBudgetAmt" mat-header-cell *matHeaderCellDef>จำนวนเงิน(บาท)</th>
          <td mat-cell *matCellDef="let element" class="text-end">{{ element.projectBudgetAmt | number: '0.2-2' }}</td>
        </ng-container>

        <ng-container matColumnDef="costCenterName">
          <th id="costCenterName" mat-header-cell *matHeaderCellDef>หน่วยงาน</th>
          <td mat-cell *matCellDef="let element">{{ element.costCenterName }}</td>
        </ng-container>

        <ng-container matColumnDef="statusName">
          <th id="statusName" mat-header-cell *matHeaderCellDef>สถานะ</th>
          <td mat-cell *matCellDef="let element">
            <button mat-button [matMenuTriggerFor]="menu">
              <mat-icon aria-hidden="false" aria-label="Example home icon">more_vert</mat-icon>
            </button>
            <mat-menu #menu="matMenu">
              <button mat-menu-item (click)="onEdit(element.projectCode)">
                <mat-icon color="primary" aria-hidden="false" aria-label="Example home icon">create</mat-icon>
                แก้ไข
              </button>
              <button mat-menu-item (click)="onDelete(element.projectCode)">
                <mat-icon color="primary" aria-hidden="false" aria-label="Example home icon">delete_outline</mat-icon>
                ยกเลิก
              </button>
            </mat-menu>
          </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
      </table>
    </div>
    <mat-paginator [pageSize]="pageSize" [pageSizeOptions]="[5, 10, 20, 50]" showFirstLastButtons aria-label="Select page of periodic elements" (page)="pageEvent = paginatorEvent($event)"> </mat-paginator>
  </div>
</mat-card>
<app-loader></app-loader>
